c**********************************************************8
c     setutop3d03:  sets up top velocity for single centered offset
c     reflects around nj for FT solver
c     version 2 puts in smoothed transform fault as well
c**********************************************************8
     
      subroutine setutop3d03(utop,nit,njt,ni,nj,loff,xlam,ylam,y0,dx,dy)
      implicit none
      integer nit,njt,ni,nj
      real utop(nit,njt)
      real loff,xlam,ylam,dx,dy

      integer i0t,j0t,njh
      integer i,j
      real x0,x1,x2,x,y,y0,y1,y2,ym
      real u1,u2,a,b

      i0t=nit/2+1
      x0=dx*(i0t-1)
      x1=x0-.5*loff
      x2=x0+.5*loff
      j0t=nj/2+1
      njh=njt/2+1

      j=1
      do i=1,nit
         x=(dx*(i-1)-x1)/xlam
         utop(i,j)=tanh(x)
      enddo
      j=njh
      do i=1,nit
         x=(dx*(i-1)-x2)/xlam
         utop(i,j)=tanh(x)
      enddo
      ym=dy*(njh-1)
c      y0=ym/2.
      y1=-y0/ylam
      y2=(ym-y0)/ylam
      do i=1,nit                ! fill in tanh smoothed in y that matches boundaries
         u1=utop(i,1)
         u2=utop(i,njh)
         b=(u1-u2)/(tanh(y1)-tanh(y2))
         a=u1-b*tanh(y1)
         do j=2,njh-1
            y=(dy*(j-1)-y0)/ylam
            utop(i,j)=a+b*tanh(y)
         enddo
      enddo 
c---  
c     now reflect around the half point
c---  
      do j=njh+1,njt
         do i=1,nit
            utop(i,j)=utop(i,2*njh-j)
         enddo
      enddo
      return
      end
      
